<template>
    <q-page class="bg-base">
        <DocumentWrapper ref="wrap">
            <div v-if="HasFloorPlan" class="relative-position full-width q-gutter-lg q-pa-lg-lg q-py-lg">
                <q-splitter v-model="splitter" :horizontal="$q.screen.height > $q.screen.width" before-class="overflow-hidden">
                    <template #before>
                        <div class="text-h5 text-weight-light text-center">
                            {{ Name }}
                        </div>
                        <div class="row justify-center relative-position">
                            <FloorPlanRender v-if='floorPlan != null' :workers="positions"
                                             :compare-time="compareTime"
                                             :floor-plan="floorPlan" @update="UpdateSize" :type="$q.screen.lg" :ratio="0.8"/>
                            <div v-else class="col-lg-6 col-12 relative-position">
                                <q-skeleton height="400px" width="100%"/>
                            </div>
                        </div>
                    </template>
                    <template #after>
                        <q-toggle v-model="randomize" label="Randomize Position"/>
                        <q-toggle v-model="autoMC" label="Auto make certain workers go on MC"/>
                        <q-toggle v-model="speedUp" label="Scaled Time Scale"/>
                        <q-input v-model.number="second" filled label="Second Scaling"/>
                        <q-input v-model="time" filled label="TimeStamp"/>
                        <q-input v-model="filterFunction" filled label="FilterFunction"/>
                        <q-input v-model.number="speed" filled type="number" label="Speed"/>
                        <q-input v-model.number="updateRate" filled type="number" label="Update Rate"/>
                        <q-list separator>
                            <q-item clickable v-ripple v-for="w in workers" :key="w.id" active-class="selected" :active="active[w.id]" @click.native="Activate(w.id)">
                                <q-item-section avatar>
                                    <q-avatar>
                                        <img :src="w.image">
                                    </q-avatar>
                                </q-item-section>

                                <q-item-section>
                                    <q-item-label>{{ w.name }}</q-item-label>
                                    <q-item-label class="ellipsis-3-lines" caption>
                                        {{ memLocation[w.id] }}
                                    </q-item-label>

                                </q-item-section>
                                <q-item-section>
                                    <q-checkbox v-model="syncWorkers[w.id]"/>
                                </q-item-section>
                                <q-item-section>
                                    <div>
                                        <q-btn flat round color="primary" icon="add" @click="AddPos(w.id)"/>
                                        <q-btn flat round color="primary" icon="content_paste" @click="Paste(w.id)" v-if="copy != null"/>
                                        <q-btn flat round color="primary" icon="content_copy" @click="Copy(w.id)" v-else/>
                                    </div>
                                </q-item-section>
                            </q-item>
                        </q-list>
                    </template>
                </q-splitter>

            </div>
            <div v-else>
                <Container :max-height="1" class="row  justify-center">
                    <div class="col-lg-6 col-12">
                        <div style="height: 100%;" class="column justify-center">
                            <LottieAnimation :data="$animations.emptyBox" :loop="false" style="height: 70%;"/>
                            <q-btn :to="`/floor/${routeParams.floorId}/floorplan/create`" color="primary">
                                Create One
                            </q-btn>
                        </div>
                    </div>
                </Container>
            </div>
        </DocumentWrapper>

    </q-page>
</template>
<style lang='scss' scoped>
.overflow-hidden {
    overflow: hidden;
}

</style>

<script lang='ts'>
import {Component, Vue} from 'vue-property-decorator';
import DocumentWrapper from "components/Core/DocumentWrapper.vue";
import {FloorResponse} from "src/classLibrary/APIModels/core/floorResponse";
import {FloorPlanFullResponse} from "src/classLibrary/APIModels/core/floorPlanFullResponse";
import Container from "components/Core/Container.vue";
import LottieAnimation from "components/Core/LottieAnimation.vue";
import {None, Option, Some} from "@hqoss/monads";
import FloorPlanRender from "components/FloorPlan/FloorPlanRender.vue";
import {WorkerPositionResponse} from "src/classLibrary/APIModels/core/workerPositionResponse";
import {WorkerPrincipalResponse} from "src/classLibrary/APIModels/core/workerPrincipalResponse";
import {PositionRequest} from "src/classLibrary/APIModels/core/positionRequest";
import {GetTimeZone, WarnMessage} from "src/classLibrary/Utility";
import {add, differenceInSeconds} from "date-fns";
import {utcToZonedTime} from "date-fns-tz";

@Component({
    components: {FloorPlanRender, LottieAnimation, Container, DocumentWrapper}
})
export default class Simulator extends Vue {
    splitter = 60;
    autoMC = false;
    copy: string | null = null
    randomize = false;
    speedUp = false;
    second = 1;
    time = (new Date()).toISOString();
    mcId: string[] = []

    filterFunction: string = '';

    compareTime = new Date();

    floor?: FloorResponse | null = null;
    floorPlan?: FloorPlanFullResponse | null = null;

    positions: { [s: string]: WorkerPositionResponse } = {};

    memLocation: { [s: string]: [number, number][] } = {};

    workers: WorkerPrincipalResponse[] = [];

    syncWorkers: { [s: string]: boolean } = {}
    active: { [s: string]: boolean } = {}

    speed = 5;
    updateRate = 1000;

    routeParams = {
        floorId: '',
    }


    rectStyle = {}

    session: number | null = null;


    Copy(id: string) {
        this.copy = id;
    }

    Paste(id: string) {
        if (this.memLocation[this.copy!] == null) return;
        this.memLocation[id] = JSON.parse(JSON.stringify(this.memLocation[this.copy!]));
        this.copy = null;
        this.saveLocation();
    }

    get Active(): string | null {
        for (let k in this.active) {
            if (this.active.hasOwnProperty(k))
                if (this.active[k])
                    return k;
        }
        return null;
    }

    move(event: KeyboardEvent) {
        const id = this.Active;
        if (id == null) return;

        const w = this.floorPlan?.info.width ?? 1;
        const h = this.floorPlan?.info.height ?? 1;

        const speedX = this.speed / 100 * w;
        const speedY = this.speed / 100 * h;

        if (this.positions[id] == null) {
            const worker = this.workers.Find(x => x.id === id)!;
            const position = new WorkerPositionResponse(
                id,
                worker.name,
                w / 2,
                h / 2,
                worker.subContractor?.color ?? "red",
                new Date().toISOString(),
                0
            )
            Vue.set(this.positions, id, position);
        }
        if (event.keyCode == 37 || event.keyCode == 65) {
            const x = (this.positions[id].x - speedX).AtMax(w).AtMin(0);
            Vue.set(this.positions[id], 'time', new Date().toISOString());
            Vue.set(this.positions[id], 'x', x);
            event.preventDefault();
        } else if (event.keyCode == 39 || event.keyCode == 68) {
            Vue.set(this.positions[id], 'time', new Date().toISOString());
            const x = (this.positions[id].x + speedX).AtMax(w).AtMin(0)
            Vue.set(this.positions[id], 'x', x);
            event.preventDefault();
        } else if (event.keyCode == 38 || event.keyCode == 87) {
            Vue.set(this.positions[id], 'time', new Date().toISOString());
            const y = (this.positions[id].y - speedY).AtMax(h).AtMin(0)
            Vue.set(this.positions[id], 'y', y);
            event.preventDefault();
        } else if (event.keyCode == 40 || event.keyCode == 83) {
            Vue.set(this.positions[id], 'time', new Date().toISOString());
            const y = (this.positions[id].y + speedY).AtMax(h).AtMin(0)
            Vue.set(this.positions[id], 'y', y);
            event.preventDefault();
        }

    }


    AddPos(id: string) {
        const pos = this.positions[id];
        this.AddLocation(id, [pos.x, pos.y]);
    }

    Activate(id: string) {
        for (let k in this.active) {
            if (this.active.hasOwnProperty(k))
                Vue.set(this.active, k, false);
        }

        Vue.set(this.active, id, true);

    }

    UpdateSize(s: any) {
        this.rectStyle = s;
    }

    generateNewSession() {
        this.session = null;
        this.session = (-999999999).RandomTo(999999999);
    }

    created() {
        this.Store.StoreValue.rightIcon = 'tune'
        this.Store.StoreValue.filter = 'floorplan'
        this.generateNewSession();
        document.addEventListener('keydown', this.move);
    }

    destroyed() {
        this.Store.StoreValue.rightIcon = ''
        this.Store.StoreValue.filter = ''
        this.session = null;
        document.removeEventListener('keydown', this.move);
    }


    get Wrap(): DocumentWrapper {
        return this.$refs.wrap as any;
    }

    get Name() {
        const fName = this.floor?.principal.name ?? '';
        const fpName = this.floorPlan?.info.name ?? '';
        return fName + "-" + fpName;
    }

    get HasFloorPlan() {
        return this.floor?.latestFloorPlan != null;
    }

    async loadWorkers(token: string) {
        const r = await this.$coreApi.Get<WorkerPrincipalResponse[]>(`Worker?projectId=${this.PersistentStore.StoreValue.project}`, null, token);
        if (r.isErr()) {
            this.Wrap.SubmitError(r.unwrapErr())
            return;
        }
        this.workers = r.unwrap();
    }

    async loadCurrentWorkers(f: FloorResponse, token: string) {
        const r = await this.$coreApi.Get<{ [s: string]: WorkerPositionResponse }>(`History/${f.principal.id}`, null, token)
        if (r.isErr()) {
            this.Wrap.SubmitError(r.unwrapErr())
            return;
        }
        this.positions = r.unwrap()
    }

    async loadFloor(token: string): Promise<Option<FloorResponse>> {
        const r = await this.$coreApi.Get<FloorResponse>(`Floor/${this.routeParams.floorId}`, null, token)
        if (r.isErr()) {
            this.Wrap.SubmitError(r.unwrapErr())
            return None;
        }
        return Some(r.unwrap());
    }

    async loadFloorPlan(f: FloorResponse, token: string) {
        if (f.latestFloorPlan != null) {
            const fpr = await this.$coreApi.Get<FloorPlanFullResponse>(`FloorPlan/${this.routeParams.floorId}/${f.latestFloorPlan.id}`, null, token)
            if (fpr.isErr()) {
                this.Wrap.SubmitError(fpr.unwrapErr())
                return
            }
            this.floorPlan = fpr.unwrap();
        }
    }

    timeZone = GetTimeZone();

    async UpdateServer(seed: number) {
        this.compareTime = new Date();
        // eval filter
        const time = new Date(this.time);
        const code = this.filterFunction;

        const tz = this.timeZone;

        function Check() {

            try {
                // @ts-ignore
                let t = utcToZonedTime(time, tz);
                const r = eval(code);
                if (r == null) return true;
                return r;
            } catch {
                return true;
            }

        }

        const c = Check();
        console.log(c);


        const bumpTime = () => {
            const old = new Date(this.time);

            if (this.speedUp) {
                const newTime = add(old, {seconds: this.second});
                const pZoneDate = utcToZonedTime(old, this.timeZone);
                const nZoneDate = utcToZonedTime(newTime, this.timeZone);
                if (pZoneDate.getDate() !== nZoneDate.getDate()) {
                    this.mcId = this.workers
                                    .Where(x => this.syncWorkers[x.id])
                                    .Where(() => (0).RandomTo(100, true) > 20)
                                    .Map(x => x.id)
                }
                this.time = newTime.toISOString();
            } else {
                const newTime = add(old, {seconds: this.updateRate / 1000});
                const s = differenceInSeconds(newTime, new Date());
                if (s < 2) {
                    this.time = new Date().toISOString();
                } else {
                    this.time = newTime.toISOString();
                }
            }
        }
        if (!c) {
            bumpTime()
            setTimeout(() => this.UpdateServer(seed), this.updateRate)
            return;
        }
        if (this.session !== seed) return;
        try {
            const request: PositionRequest[] = [];
            for (let k in this.positions) {
                if (this.positions.hasOwnProperty(k)) {
                    const pos = this.positions[k];
                    const ml = this.memLocation[pos.id];
                    if (this.randomize && ml != null && ml.length > 0) {
                        const [x, y] = ml.Random()!;
                        Vue.set(this.positions[k], 'x', x);
                        Vue.set(this.positions[k], 'y', y);
                        pos.x = x;
                        pos.y = y;
                    }
                    const sync = this.syncWorkers[pos.id];
                    if (sync && (!this.autoMC || this.mcId.Has(pos.id))) {
                        const worker = this.workers.Find(x => x.id === pos.id);
                        request.push(new PositionRequest(
                            this.floor?.principal.id ?? "",
                            worker?.tag ?? "",
                            pos.x ?? 0,
                            pos.y ?? 0
                        ))
                    }
                }
            }
            // bump time
            bumpTime();

            if (request.length > 0) {

                const token = await this.$auth.CoreToken;
                const timeQuery = `?alternateStamp=${this.time}`
                const r = await this.$coreApi.QPost(`Proxy/${this.PersistentStore.StoreValue.project}/batch${timeQuery}`, request, token);
                if (r.isSome()) {
                    this.$q.notify(WarnMessage('Failed to post proxy/batch'));
                    console.error(r.unwrap());
                }
            }


            setTimeout(() => this.UpdateServer(seed), this.updateRate)
        } catch {
            setTimeout(() => this.UpdateServer(seed), this.updateRate)
        }


    }

    AddLocation(workerId: string, pos: [number, number]) {
        if (this.memLocation[workerId] == null) this.memLocation[workerId] = [];

        this.memLocation[workerId].push(pos);
        this.saveLocation();
    }

    saveLocation() {
        const serial = JSON.stringify(this.memLocation);
        const pid = this.PersistentStore.StoreValue.project;
        localStorage.setItem(`sim-mem-${pid}-${this.floor?.principal.id}`, serial);
    }

    loadMemory() {
        const pid = this.PersistentStore.StoreValue.project;

        const mem = localStorage.getItem(`sim-mem-${pid}-${this.floor?.principal.id}`);

        if (mem == null || mem == "") {
            this.memLocation = {};
        } else {
            this.memLocation = JSON.parse(mem);
        }
    }

    async init() {
        const token = await this.$auth.CoreToken;
        const f = await this.loadFloor(token);
        if (f.isNone()) return;
        this.floor = f.unwrap();
        await this.loadFloorPlan(this.floor!, token);
        await this.loadCurrentWorkers(this.floor!, token);
        await this.loadWorkers(token)

        // Load memory
        this.loadMemory();

        this.generateNewSession();
        this.UpdateServer(this.session!).then();
    }


}
</script>

